var qickBookmarks = {
	buttonId: "qickBookmarksButton",
	cbAPI: qickBookmarksCbAPI,
	initialized: false,
	init: function() {
		window.removeEventListener("load", this, false);
		this.initButton();
	},
	initButton: function() {
		if(this.initialized || !this.button)
			return;
		this.cbInit.call(this.button, this.cbAPI);
		this.initialized = true;
	},
	checkInit: function() {
		this.button.onmouseover = null;
		this.initButton();
	},
	command: function() {
		if(!this.initialized)
			this.initButton();
		this.cbCode.call(this.button, this.cbAPI);
	},
	cbCode: function(custombuttons) {
		/*CODE*/
	},
	cbInit: function(custombuttons) {
		/*Initialization Code*/
		var profileDir = Components.classes["@mozilla.org/file/directory_service;1"]
			.getService(Components.interfaces.nsIProperties)
			.get("ProfD", Components.interfaces.nsILocalFile)
			.path;
		var path = profileDir + "\\tabbookmarks.xml";
		var loadInBackground = true;

		this. handleDragOver = function (event)
		{
			var dt = event. dataTransfer;
			var tab = dt. mozGetDataAt (TAB_DROP_TYPE, 0);
			if (!tab)
				return;
			event. preventDefault ();
			event. stopPropagation ();
			return dt. effectAllowed = dt. dropEffect = "link";
		}

		this. handleDrop = function (event)
		{
			var dt = event. dataTransfer;
			var url = dt. mozGetDataAt ("text/x-moz-text-internal", 0);
			var tab = dt. mozGetDataAt (TAB_DROP_TYPE, 0);
			var label = tab. label;
			var image = tab. image;
			var br = getBrowser ();
			//if (br. tabContainer. childNodes. length > 1)
				br. removeTab (tab);
			this. addMenuitem (label, url, image);
		};

		this. addMenuitem = function (label, url, image)
		{
			var menu = this. menu;
			var mi = document. createElement ("menuitem");
			mi. setAttribute ("label", label);
			mi. setAttribute ("url", url);
			mi. setAttribute ("tooltiptext", url);
			mi. className = "menuitem-iconic bookmark-item";
			image && mi. setAttribute ("image", "moz-anno:favicon:" + image);
			menu. appendChild (mi);
			this. type = "menu";
			this. flushMenu (menu);
		};

		this. deleteMenuitem = function (menuitem)
		{
			var menu = this. menu;
			menu. removeChild (menuitem);
			this. checkEmpty (menu);
			this. flushMenu (menu);
		};

		this. checkEmpty = function (menu)
		{
			if (menu. getElementsByTagName ("menuitem"). length > 0)
				return;
			menu. hidePopup ();
			this. type = "";
		};

		this. flushMenu = function (menu)
		{
			menu = menu || this. menu;
			var xs = new XMLSerializer ();
			var xmenu = xs. serializeToString (menu);
			var suc = Components. classes ["@mozilla.org/intl/scriptableunicodeconverter"].
					  createInstance (Components. interfaces. nsIScriptableUnicodeConverter);
			suc. charset = "UTF-8";
			xmenu = suc. ConvertFromUnicode (xmenu);
			custombuttons. writeFile (path, xmenu);
		};

		this. getMenu = function (event)
		{
			var menu = this. menu;
			if (menu)
				this. removeChild (menu);
			menu = "";
			try
			{
				file = Components. classes ["@mozilla.org/file/local;1"].
					   createInstance (Components. interfaces. nsILocalFile);
				file. initWithPath (path);
				var fis = Components. classes ["@mozilla.org/network/file-input-stream;1"].
						  createInstance (Components. interfaces. nsIFileInputStream);
				fis.init (file, 0x01, 00004, null);
				var sis = Components. classes ["@mozilla.org/scriptableinputstream;1"].
						  createInstance (Components. interfaces. nsIScriptableInputStream);
				sis. init (fis);
				menu = sis. read (sis. available ());
				sis. close ();
				var suc = Components. classes ["@mozilla.org/intl/scriptableunicodeconverter"].
						  createInstance (Components. interfaces. nsIScriptableUnicodeConverter);
				suc. charset = "UTF-8";
				menu = suc. ConvertToUnicode (menu);
				menu = new XML (menu) || "";
			}
			catch (e)
			{
				menu = "";
			}
			if (!menu)
			{
				menu =
				<menupopup xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
					   onclick="this. parentNode. openTab (event);"/>
			}
			menu = new DOMParser (). parseFromString (menu. toXMLString (), "application/xml"). documentElement;
			this. appendChild (menu);
			if (menu. getElementsByTagName ("menuitem"). length > 0)
				this. type = "menu";
			this. orient = "horizontal";
			return menu;
		};

		this. __defineGetter__
		(
			"menu",
			function ()
			{
				return this. getElementsByTagName("menupopup") [0];
			}
		);

		this. openTab = function (event)
		{
			var mi = event. target;
			var menu = mi. parentNode;
			var url = mi. getAttribute ("url");
			if (event. button < 2)
			{
				if (event. button == 0)
					getBrowser (). loadURI (url, null, null);
				else
					getBrowser (). loadOneTab(url, null, null, null, loadInBackground, false);
				menu. hidePopup ();
			}
			else
				event. stopPropagation ();
			this. deleteMenuitem (mi);
			this. flushMenu (menu);
		};

		this. onclick = function (event)
		{
			if (event. button != 1 || event. target != this)
				return;
			var menu = this. menu;
			var mis = menu. getElementsByTagName ("menuitem");
			var mi;
			while (mis. length)
			{
				mi = mis[0];
				getBrowser (). loadOneTab(mi. getAttribute ("url"), null, null, null, true /*load in background*/, false);
				menu. removeChild (mi);
			}
			this. checkEmpty (menu);
			this. flushMenu (menu);
		};

		this. setAttribute ("ondragdrop", "return this. handleDrop (event);");
		this. setAttribute ("ondragover", "return this. handleDragOver (event);");
		this. setAttribute ("onmouseover", "if (event. target == this) this. getMenu (event);");
		this. getMenu ();
	},
	get button() {
		var button = document.getElementById(this.buttonId);
		if(!button)
			return null;
		delete this.button;
		return this.button = button;
	},
	handleEvent: function(e) {
		switch(e.type) {
			case "load": this.init(e); break;
		}
	}
};
window.addEventListener("load", qickBookmarks, false);